//
// Created by nicolas on 23/03/18.
//

#include <stdarg.h>
#include "array.h"
#include "debug.h"

array_t* array_create(size_t n, ...) {
    va_list vl;
    va_start(vl, n);

    array_t* arr = malloc(sizeof(array_t));
    arr->size = n;
    arr->data = malloc(n * sizeof(void*));

    for (size_t i = 0; i < n; i++) {
        void* item = va_arg(vl, void*);
        arr->data[i] = item;
    }

    return arr;
}

void array_destroy(array_t* array, array_deallocator destroyer) {
    if (destroyer) {
        for (size_t i=0;i<array->size;i++) {
            destroyer(array->data[i]);
        }
    }
    free(array->data);
    free(array);
}
